﻿'   GDM-8000 Socket Sample Program　for Vb2008 or Higher
'   Please Open project (.vbproj), Not Open Solution
'   ソリューションファイルでなくプロジェクトファイル(.vbproj)を開いてください。

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms

Public Class mainForm

    Private Opened As Integer
    Private m_TcpClient As System.Net.Sockets.TcpClient
    Private m_NetworkStream As System.Net.Sockets.NetworkStream
    Private txtBuff As String

    ' OPNE/CLOSE
    Private Sub btnOpen_Close_Click(sender As Object, e As EventArgs) Handles btnOpen_Close.Click

        Opened = 1
        If (btnOpen_Close.Text = "OPEN") Then
            Try
                Cursor.Current = Cursors.WaitCursor
                ' Device Open and Init
                m_TcpClient = New System.Net.Sockets.TcpClient
                m_TcpClient.Connect(txtIPAddress.Text, txtIPPort.text)
                m_NetworkStream = m_TcpClient.GetStream

                ' Set form
                btnAUTO.Text = "AUTO ON"
                btnOpen_Close.Text = "CLOSE"
                btnAUTO.Enabled = True
                btnMonitor.Enabled = True
                btnACV.Enabled = True
                btnDCV.Enabled = True
                btnDCI.Enabled = True
                btnFREQ.Enabled = True
                txtIPAddress.Enabled = False
                txtIPPort.Enabled = False
                txtBuff = Readbuff()

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            Finally
                Cursor.Current = Cursors.Default
            End Try
        Else
            Try
                'Device Close
                WriteLine("CONF:AUTO OFF" + vbLf)
                WriteLine("SYST:LOC" + vbLf)
                System.Threading.Thread.Sleep(200)

                If ((m_TcpClient IsNot Nothing) AndAlso (m_TcpClient.Connected = True)) Then
                    m_NetworkStream.Close()
                    m_TcpClient.Close()
                End If
                m_NetworkStream = Nothing
                m_TcpClient = Nothing

                'Set form
                btnOpen_Close.Text = "OPEN"
                btnAUTO.Enabled = False
                btnMonitor.Enabled = False
                btnACV.Enabled = False
                btnDCV.Enabled = False
                btnDCI.Enabled = False
                btnFREQ.Enabled = False
                txtIPAddress.Enabled = True
                txtIPPort.Enabled = True

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    'Form Close(x Button)
    Private Sub mainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        'Device Close
        If (txtIPAddress.Enabled = False) Then
            WriteLine("CONF:AUTO OFF" + vbLf)
            System.Threading.Thread.Sleep(200)
        End If
        If (Opened <> 0) Then
            If ((m_TcpClient IsNot Nothing) AndAlso (m_TcpClient.Connected = True)) Then
                m_NetworkStream.Close()
                m_TcpClient.Close()
            End If
            m_NetworkStream = Nothing
            m_TcpClient = Nothing
        End If
    End Sub

    'Load ON/OFF
    Private Sub btnLoad_Click(sender As Object, e As EventArgs)
        If (btnAUTO.Text = "AUTO ON") Then
            ' OFF -> ON
            WriteLine("CONF:AUTO ON" + vbLf)
            btnAUTO.Text = "AUTO OFF"
        Else
            ' ON -> OFF
            WriteLine("CONF:AUTO OFF" + vbLf)
            btnAUTO.Text = "AUTO ON"
        End If
    End Sub


    ' Monitor
    Private Sub btnMonitor_Click(sender As Object, e As EventArgs) Handles btnMonitor.Click
        Try
            Cursor.Current = Cursors.WaitCursor

            WriteLine("READ?" + vbLf)
            System.Threading.Thread.Sleep(500)
            txtMeasure.Text = Readbuff()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            Cursor.Current = Cursors.Default
        End Try
    End Sub

    'Load
    Private Sub mainForm_Load(sender As Object, e As EventArgs) Handles Me.Load

        Opened = 0

        ' Set form
        btnOpen_Close.Text = "OPEN"
        btnAUTO.Enabled = False
        btnMonitor.Enabled = False
        btnACV.Enabled = False
        btnDCV.Enabled = False
        btnDCI.Enabled = False
        btnFREQ.Enabled = False
        txtIPAddress.Enabled = True
        txtIPPort.Enabled = True
    End Sub

    Private Sub btnAUTO_Click(sender As System.Object, e As System.EventArgs) Handles btnAUTO.Click
        If (btnAUTO.Text = "AUTO ON") Then
            ' OFF -> ON
            WriteLine("CONF:AUTO ON" + vbLf)
            btnAUTO.Text = "AUTO OFF"
        Else
            ' ON -> OFF
            WriteLine("CONF:AUTO OFF" + vbLf)
            btnAUTO.Text = "AUTO ON"
        End If
    End Sub

    Private Sub btnDCV_Click(sender As System.Object, e As System.EventArgs) Handles btnDCV.Click
        WriteLine("CONF:VOLT:DC" + vbLf)
    End Sub

    Private Sub btnACV_Click(sender As System.Object, e As System.EventArgs) Handles btnACV.Click
        WriteLine("CONF:VOLT:AC" + vbLf)
    End Sub

    Private Sub btnDCI_Click(sender As System.Object, e As System.EventArgs) Handles btnDCI.Click
        WriteLine("CONF:CURR:DC" + vbLf)

    End Sub

    Private Sub btnFREQ_Click(sender As System.Object, e As System.EventArgs) Handles btnFREQ.Click
        WriteLine("CONF:FREQ" + vbLf)

    End Sub

    'Wirte Message by socket
    Private Sub WriteLine(sendMsg As String)
        Dim SendBuff() As Byte = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetBytes(sendMsg)

        m_NetworkStream.Write(SendBuff, 0, SendBuff.Length)
        m_NetworkStream.Flush()

    End Sub

    'read Message by socket
    Private Function Readbuff() As String
        Dim reciveBuff As Byte() = New Byte(256) {}
        Dim DataCnt As Integer = m_TcpClient.Available

        If (DataCnt > 255) Then DataCnt = 255
        m_NetworkStream.Read(reciveBuff, 0, DataCnt)
        Readbuff = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(reciveBuff).Substring(0, DataCnt)

    End Function
End Class
